/*
TASK: cells
LANG: C++
*/

#include <iostream>
#include <cmath>
using namespace std;

int n, m;

int NOD( int a, int b )
{
    if ( b > a )
       return NOD( b, a );
    a = a % b;
    if ( a == 0 )
       return b;
    if ( b == 0 )
       return a;
    return NOD( a, b );
}

int delnum( int k )
{
    int i, res = 0;
    double j = sqrt( k );
    i = 2;
    while ( ( k > 1 ) && ( i < j ) )
    {
          while ( k % i == 0 )
          {
                res++;
                k = k / i;
          }
          i++;
    }
    if ( k > 1 )
       res++;
    return res;
}

int main()
{
    int i, j;
    int p, t;
    cin >> n >> m;
    
    i = NOD( n, m );
    p = max( n, m );
    t = min( n, m );
    p = p / i;
    t = t / i;
    j = delnum( p ) + delnum( t );
    cout << j << endl;
    return 0;
}
