/*
TASK: tri
LANG: C++
*/

#include <iostream>
#include <cmath>
using namespace std;

struct point
{
       long long x, y;
};

struct vector
{
       long long a, b;
       long long operator*( const vector c )
       {
              return a*c.b - c.a*b;
       }
};

point A, B, C;
point O;
vector AB, BC, CA;
vector AO, BO, CO;
double x, y, z;
double sol;
long long S;

double min( double a, double b )
{
       if ( a < b )
          return a;
       return b;
}

double len( point a, point b )
{
       return (double) sqrt( ( a.x - b.x ) * ( a.x - b.x ) + ( a.y - b.y ) * ( a.y - b.y ) );
}

int main()
{
    cin >> A.x >> A.y >> B.x >> B.y >> C.x >> C.y;
    cin >> O.x >> O.y;
    AB.a = B.x - A.x;
    AB.b = B.y - A.y;
    BC.a = C.x - B.x;
    BC.b = C.y - B.y;
    CA.a = A.x - C.x;
    CA.b = A.y - C.y;
    AO.a = O.x - A.x;
    AO.b = O.y - A.y;
    BO.a = O.x - B.x;
    BO.b = O.y - B.y;
    CO.a = O.x - C.x;
    CO.b = O.y - C.y;
    
    x = (double)abs((AB*AO))/len( A, B );
    y = (double)abs((BC*BO))/len( B, C );
    z = (double)abs((CA*CO))/len( A, C );
    
    sol = min( x, min( y, z ) );
    S = int (sol * 100000);
    sol = (double) S / 100000;
    printf( "%.5f\n", sol );
    return 0;
}
