/*
TASK: line
LANG: C++
*/

#include <iostream>
#include <cmath>
using namespace std;

struct point
{
       int x, y;
};

struct vector
{
       double a, b;
       double operator*( const vector c )
       {
              return a*c.b - c.a*b;
       }
};

int n, w, e;
point A, B;
point S1, S2, S3, S4;
vector AB, v;
int br = 0;

void P2V( point a, point b )
{
       vector v;
       double pr;
       v.a = b.x - a.x;
       v.b = b.y - a.y;
       pr = AB * v;
       if ( pr < 0 )
       {
          br--;
       }
       else if ( pr > 0 )
       {
          br++;
       }
}

int main()
{
    int i, j, k = 0;
    cin >> n >> w >> e;
    
    A.x = 0;
    A.y = w;
    B.x = 100 * n;
    B.y = e;
    AB.a = B.x - A.x;
    AB.b = B.y - A.y;
    for ( i = 1; i <= n; i++ )
    {
        for ( j = 1; j <= n; j++ )
        {
            S1.x = 100 * i;
            S1.y = 100 * j;
            S2.x = 100 * i - 100;
            S2.y = 100 * j - 100;
            S3.x = 100 * i;
            S3.y = 100 * j - 100;
            S4.x = 100 * i - 100;
            S4.y = 100 * j;

            br = 0;
            P2V( A, S1 );
            P2V( A, S2 );
            P2V( A, S3 );
            P2V( A, S4 );
            if ( abs( br ) != 4 )
               k++;
        }
    }
    cout << k << endl;
    return 0;
}
